#include "cti_byte_io.h"

float vf2(unsigned char *bytegroup);

short Short_Rev(short in)
{
  static unsigned char byte_arr[4];
  static short out;

  memcpy(byte_arr,&in,2);
  
  byte_arr[2]=byte_arr[0];
  byte_arr[0]=byte_arr[1];
  byte_arr[1]=byte_arr[2];
  
  memcpy(&out,byte_arr,2);

  return(out);

}


long Long_Rev(long in)
{
  static unsigned char *byte_ptr_in, *byte_ptr_out;
  static long out;
  static int i;

  byte_ptr_in=(unsigned char*)&in;
  byte_ptr_out=(unsigned char*)&out;

  for (i=0;i<4;i++)
    byte_ptr_out[i]=byte_ptr_in[3-i];

  /*for (i=0;i<4;i++)
   printf("%d\n",(int)byte_ptr_in[i]);
  for (i=0;i<4;i++)
   printf("%d\n",(int)byte_ptr_out[i]);
  printf("in=%d out=%d\n",(int)in,(int)out);

  printf("sizeof(long)=%d\n",sizeof(long));
  exit(-1);
*/

  return(out);

}


void read_sh_arr(short *arr, int len, FILE *fp, int BYTE_ORDER)
{
  int stat,i;

  stat=fread(arr,sizeof(short),len,fp);
  
  if (stat!=len)
    {
      fprintf(stderr,"Read error read_sh_arr, stat=%d, len=%d.\n\a\n",stat,len);
      exit(-1);
    }
  
  if (BYTE_ORDER)
    for (i=0;i<len;i++)
      arr[i]=Short_Rev(arr[i]);
  
}



void write_sh_arr(short *arr, int len, FILE *fp, int BYTE_ORDER)
{
  int stat,i;

  if (BYTE_ORDER)
    for (i=0;i<len;i++)
      arr[i]=Short_Rev(arr[i]);
  
  stat=fwrite(arr,sizeof(short),len,fp);
  
  if (stat!=len)
    {
      fprintf(stderr,"Write error read_sh_arr, stat=%d, len=%d.\n\a\n",stat,len);
      exit(-1);
    }
  
  /* after write, change byte-order back */
  if (BYTE_ORDER)
    for (i=0;i<len;i++)
      arr[i]=Short_Rev(arr[i]);
}






void read_lg_arr(long *arr, int len, FILE *fp, int BYTE_ORDER)
{
  int stat,i;

  stat=fread(arr,sizeof(long),len,fp);
  
  if (stat!=len)
    {
      fprintf(stderr,"Read error read_lg_arr, stat=%d, len=%d.\n\a\n",stat,len);
      exit(-1);
    }
  
  if (BYTE_ORDER)
    for (i=0;i<len;i++)
      arr[i]=Long_Rev(arr[i]);
  
}


void write_lg_arr(long *arr, int len, FILE *fp, int BYTE_ORDER)
{
  int stat,i;
 

  if (BYTE_ORDER)
    for (i=0;i<len;i++)
      arr[i]=Long_Rev(arr[i]);
  
  stat=fwrite(arr,sizeof(long),len,fp);
  
  if (stat!=len)
    {
      fprintf(stderr,"Write error write_lg_arr, stat=%d, len=%d.\n\a\n",stat,len);
      exit(-1);
    }

  /* after writing, change byte-order back to original */
  if (BYTE_ORDER)
    for (i=0;i<len;i++)
      arr[i]=Long_Rev(arr[i]);
  
}




void read_float_arr(float *arr, int len, FILE *fp)
{
  int stat,i;
  static unsigned char *bytearr;

  bytearr=(unsigned char*)arr;

  stat=fread(bytearr,sizeof(unsigned char),4*len,fp);
  
  if (stat!=4*len)
    {
      fprintf(stderr,"Read error floats, stat=%d, 4*len=%d.\n\a\n",stat,4*len);
      exit(-1);
    }
  
  for (i=0;i<len;i++)
    arr[i]=vax_float_2_float(&bytearr[4*i]);

  
}



void write_float_arr(float *arr, int len, FILE *fp, int BYTE_ORDER)
{
  static int stat,i;
  static unsigned char *vax_arr;
  static unsigned char vaxf[5];

  if (len==1)
    {
      float_2_vaxfloat(vaxf,arr[0],BYTE_ORDER);
      stat=fwrite(vaxf,sizeof(unsigned char),4*len,fp);
    }
  else
    {
      vax_arr=(unsigned char*)get_spc(4*len,sizeof(unsigned char));
  
      for (i=0;i<len;i++)
	float_2_vaxfloat(&vax_arr[4*i],arr[i],BYTE_ORDER);
  
      stat=fwrite(vax_arr,sizeof(unsigned char),4*len,fp);
      free((void*)vax_arr);
    }

  if (stat!=4*len)
    {
      fprintf(stderr,"Write error floats, stat=%d, 4*len=%d.\n\a\n",stat,4*len);
      exit(-1);
    }
  
}


void float_2_vaxfloat(unsigned char *bytearr_out, float in, int BYTE_ORDER)
{
  /*float out;*/
  static unsigned char bytearr_in[5];
  static unsigned char bytearr_tmp[5];
  /*static unsigned char bytearr_out[5];*/

  memcpy(bytearr_in,&in,4);
  /*printf("incoming float bytes: [%d %d %d %d]\n",bytearr_in[0],bytearr_in[1],bytearr_in[2],bytearr_in[3]);*/

 if (BYTE_ORDER)
   {


     bytearr_tmp[0]=bytearr_in[0] + 1; /* should be + binary 1 */
     bytearr_tmp[1]=bytearr_in[1];
     bytearr_tmp[2]=bytearr_in[2];
     bytearr_tmp[3]=bytearr_in[3];

     bytearr_out[0]=bytearr_tmp[1];
     bytearr_out[1]=bytearr_tmp[0];
     bytearr_out[2]=bytearr_tmp[3];
     bytearr_out[3]=bytearr_tmp[2];
     
     /*memcpy(&out,bytearr_out,4);*/
     
   }
 else
   {
     bytearr_tmp[0]=bytearr_in[3] + 1; /* should be + binary 1 */
     bytearr_tmp[1]=bytearr_in[2];
     bytearr_tmp[2]=bytearr_in[1];
     bytearr_tmp[3]=bytearr_in[0];

     bytearr_out[0]=bytearr_tmp[1];
     bytearr_out[1]=bytearr_tmp[0];
     bytearr_out[2]=bytearr_tmp[3];
     bytearr_out[3]=bytearr_tmp[2];
    
     /*memcpy(&out,bytearr_out,4);*/
     

     /*fprintf(stderr,"WARNING:float_2_vaxfloat not implemented, setting to 0.\n");
       out=0.0;*/
   }
  
 /*return(out);*/
}

/*
float vax_float_2_float(unsigned char *bytegroup)
{
  unsigned char byte; 
  double m1,m2,m3,mantissa,exponent,fraction;
  int signbit,characts;
  float g_n;
float g_n2;


printf("vaxfloat bytes: [%d %d %d %d] ->",bytegroup[0],bytegroup[1],bytegroup[2],bytegroup[3]);
  
 
  byte        =bytegroup[0];
  bytegroup[0]=bytegroup[1];
  bytegroup[1]=byte;
  
 
  byte        =bytegroup[2];
  bytegroup[2]=bytegroup[3];
  bytegroup[3]=byte;
  
  signbit  = (bytegroup[0] &  0x80);
  characts = (int)( 2.0*(float)( bytegroup[0] &  0x7f ) + (double)( bytegroup[1] & 0x80 )/128.0 ); 
 
  
  m3 =	  (double)( bytegroup[3])/pow(2.0,24.0);  	
  m2 = 	  (double)( bytegroup[2])/pow(2.0,16.0);  	
  m1 = 	  (double)( (bytegroup[1] & 0x7f ) + 0x80)/pow(2.0,8.0);
  
  mantissa = m1+m2+m3;
  fraction = mantissa; 
  exponent = (double)characts - 128.0;   
  
  g_n = (float)(( 1.0 - 2.0*signbit ) * fraction * pow(2.0,exponent));

printf("%f\n",g_n);

float_2_vaxfloat(bytegroup,g_n,1);

printf("converted back bytes = [%d %d %d %d] \n",bytegroup[0],bytegroup[1],bytegroup[2],bytegroup[3]);

g_n2=vf2(bytegroup);


printf("and forward again: %f\n",g_n2);

 if (fabs(g_n2-g_n)>0.001)
  {
    printf("Error: g_n=%g g_n2=%g diff=%g\n",g_n,g_n2,g_n-g_n2);
    exit(-1);
  }
  return(g_n);
}
*/

float vax_float_2_float(unsigned char *bytegroup)
{
  unsigned char byte; 
  double m1,m2,m3,mantissa,exponent,fraction;
  int signbit,characts;
  float g_n;

  byte        =bytegroup[0];
  bytegroup[0]=bytegroup[1];
  bytegroup[1]=byte;
  
 
  byte        =bytegroup[2];
  bytegroup[2]=bytegroup[3];
  bytegroup[3]=byte;
  
  signbit  = (bytegroup[0] &  0x80);
  characts = (int)( 2.0*(float)( bytegroup[0] &  0x7f ) + (double)( bytegroup[1] & 0x80 )/128.0 ); 
 
  
  m3 =	  (double)( bytegroup[3])/pow(2.0,24.0);  	
  m2 = 	  (double)( bytegroup[2])/pow(2.0,16.0);  	
  m1 = 	  (double)( (bytegroup[1] & 0x7f ) + 0x80)/pow(2.0,8.0);
  
  mantissa = m1+m2+m3;
  fraction = mantissa; 
  exponent = (double)characts - 128.0;   
  
  g_n = (float)(( 1.0 - 2.0*signbit ) * fraction * pow(2.0,exponent));


  return(g_n);
}



int test_byte_order()
{
  unsigned char bytearr[4];
  short test;
  int byte_order=0;

  bytearr[0]=(unsigned char)0;
  bytearr[1]=(unsigned char)128;
  
  memcpy(&test,bytearr,2);
  /*printf("test=%d\n",(int)test);*/
  
  if (test==-32768)
    byte_order=0;  /* PC */
  else if (test==128)
    byte_order=1; /* HP, SUN */
  else
    {
      fflush(stdout);fflush(stderr);
      fprintf(stderr,"Error: Unknown byte-order of this hardware\n\a\n");
      exit(-1);
    }
  
  return(byte_order);
}

