#include "cti_structs.h"

void read_main_header(struct main_head *mh, FILE *fp, int BYTE_ORDER)
{
 fread(mh->fill,sizeof(short),14,fp); 		
 fread(mh->original_file_name,sizeof(char),20,fp);


 read_sh_arr(&mh->sw_version, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->data_type, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->system_type, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->file_type, 1, fp, BYTE_ORDER);

 fread(mh->node_id,sizeof(char),10,fp);
 
 read_sh_arr(&mh->scan_start_day, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->scan_start_month, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->scan_start_year, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->scan_start_hour, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->scan_start_minute, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->scan_start_second, 1, fp, BYTE_ORDER);

 
 fread(mh->isotope_code,sizeof(char),8,fp);
 
 read_float_arr(&mh->isotope_halflife, 1, fp);
 
 fread(mh->radiopharmaceutical,sizeof(char),32,fp);
 

 read_float_arr(&mh->gantry_tilt, 1, fp);
 read_float_arr(&mh->gantry_rotation, 1, fp);
 read_float_arr(&mh->bed_elevation, 1, fp);
 
 read_sh_arr(&mh->rot_source_speed, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->wobble_speed, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->transm_source_type, 1, fp, BYTE_ORDER);

 read_float_arr(&mh->axial_fov, 1, fp);
 read_float_arr(&mh->transaxial_fov, 1, fp);
 
 read_sh_arr(&mh->transaxial_samp_mode, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->coin_samp_mode, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->axial_samp_mode, 1, fp, BYTE_ORDER);
 
 read_float_arr(&mh->calibration_factor, 1, fp);
 
 read_sh_arr(&mh->calibration_units, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->compression_code, 1, fp, BYTE_ORDER);

 fread(mh->study_info,sizeof(char),188,fp);
 
 read_sh_arr(&mh->aquisition_type, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->bed_type, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->septa_type, 1, fp, BYTE_ORDER);

 fread(mh->facility_name,sizeof(char),20,fp);
 
 read_sh_arr(&mh->num_planes, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->num_frames, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->num_gates, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->num_bed_pos, 1, fp, BYTE_ORDER);

 read_float_arr(&mh->init_bed_pos, 1, fp);
 read_float_arr(mh->bed_offsets, 15, fp);
 read_float_arr(&mh->plane_separation, 1, fp);

 read_sh_arr(&mh->lwr_sctr_thres, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->lwr_true_thres, 1, fp, BYTE_ORDER);
 read_sh_arr(&mh->upr_true_thres, 1, fp, BYTE_ORDER);

 read_float_arr(&mh->collimator, 1, fp);

 fread(mh->fill2,sizeof(short),25,fp);
 
 if (ftell(fp)!=512)
   {
     fprintf(stderr,"Error: Read != 512 bytes for main header. Wrong hardware architecture?.\n\a\n");
     exit(-1);
   }
}

void write_main_header(FILE *fp, struct main_head *mh, int BYTE_ORDER)
{
  long dir_1st_entry[130];
  int i;
  /*fp=fopen(fname,"w");
  if (fp==NULL)
    {
      fflush(stdout);fflush(stderr);
      fprintf(stderr,"Can't open output file %s for writing main header\n\a\n",fname);
      exit(-1);
    }
  */
  for (i=0;i<14;i++)
    mh->fill[i]=(short)0;
  /*fwrite(mh->fill,sizeof(short),14,fp);*/ 		
  write_sh_arr(mh->fill, 14, fp, BYTE_ORDER);
  fwrite(mh->original_file_name,sizeof(char),20,fp);
  
  
  write_sh_arr(&mh->sw_version, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->data_type, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->system_type, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->file_type, 1, fp, BYTE_ORDER);
  
  fwrite(mh->node_id,sizeof(char),10,fp);
  
  write_sh_arr(&mh->scan_start_day, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->scan_start_month, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->scan_start_year, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->scan_start_hour, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->scan_start_minute, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->scan_start_second, 1, fp, BYTE_ORDER);
  
  
  fwrite(mh->isotope_code,sizeof(char),8,fp);
  
  write_float_arr(&mh->isotope_halflife, 1, fp, BYTE_ORDER);
  
  fwrite(mh->radiopharmaceutical,sizeof(char),32,fp);
  
  
  write_float_arr(&mh->gantry_tilt, 1, fp, BYTE_ORDER);
  write_float_arr(&mh->gantry_rotation, 1, fp, BYTE_ORDER);
  write_float_arr(&mh->bed_elevation, 1, fp, BYTE_ORDER);
  
  write_sh_arr(&mh->rot_source_speed, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->wobble_speed, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->transm_source_type, 1, fp, BYTE_ORDER);
  
  write_float_arr(&mh->axial_fov, 1, fp, BYTE_ORDER);
  write_float_arr(&mh->transaxial_fov, 1, fp, BYTE_ORDER);
  
  write_sh_arr(&mh->transaxial_samp_mode, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->coin_samp_mode, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->axial_samp_mode, 1, fp, BYTE_ORDER);
  
  write_float_arr(&mh->calibration_factor, 1, fp, BYTE_ORDER);
  
  write_sh_arr(&mh->calibration_units, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->compression_code, 1, fp, BYTE_ORDER);
  
  fwrite(mh->study_info,sizeof(char),188,fp);
  
  write_sh_arr(&mh->aquisition_type, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->bed_type, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->septa_type, 1, fp, BYTE_ORDER);
  
  fwrite(mh->facility_name,sizeof(char),20,fp);
  
  write_sh_arr(&mh->num_planes, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->num_frames, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->num_gates, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->num_bed_pos, 1, fp, BYTE_ORDER);
  
  write_float_arr(&mh->init_bed_pos, 1, fp, BYTE_ORDER);
  write_float_arr(mh->bed_offsets, 15, fp, BYTE_ORDER);
  write_float_arr(&mh->plane_separation, 1, fp, BYTE_ORDER);
  
  write_sh_arr(&mh->lwr_sctr_thres, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->lwr_true_thres, 1, fp, BYTE_ORDER);
  write_sh_arr(&mh->upr_true_thres, 1, fp, BYTE_ORDER);
  
  write_float_arr(&mh->collimator, 1, fp, BYTE_ORDER);
  

  for (i=0;i<25;i++)
    mh->fill2[i]=(short)0;
  write_sh_arr(mh->fill2, 25, fp, BYTE_ORDER);
  /*fwrite(mh->fill2,sizeof(short),25,fp);*/
 
  if (ftell(fp)!=512)
    {
      fprintf(stderr,"Error: Wrote != 512 bytes for main header. Wrong hardware architecture?.\n\a\n");
      exit(-1);
    }



  /* after writing the header, we have to write first directory entry */
  dir_1st_entry[0]=(long)31;
  dir_1st_entry[1]=(long)2;
  dir_1st_entry[2]=(long)0;
  dir_1st_entry[3]=(long)0;
 
  write_lg_arr(dir_1st_entry, 128, fp, BYTE_ORDER);

}


void init_main_header(struct main_head *mh)
{
  int i;

  strcpy(mh->original_file_name,"                    "); /* 20 blanks */
  mh->sw_version=(short)0;
  mh->data_type =(short)0;
  mh->system_type =(short)0;
  mh->file_type =(short)0;

  strcpy(mh->node_id,"          "); /* 10 blanks */
  
  mh->scan_start_day=(short)0;
  mh->scan_start_month=(short)0;
  mh->scan_start_year=(short)0;
  mh->scan_start_hour=(short)0;
  mh->scan_start_minute=(short)0;
  mh->scan_start_second=(short)0;

  strcpy(mh->isotope_code,"        "); /* 8 blanks */
  
  mh->isotope_halflife=(float)0.0;
  
  strcpy(mh->radiopharmaceutical,"                                ");
  
  mh->gantry_tilt=(float)0.0;
  mh->gantry_rotation=(float)0.0;
  mh->bed_elevation=(float)0.0;
  
  mh->rot_source_speed=(short)0;
  mh->wobble_speed=(short)0;
  mh->transm_source_type=(short)0;

  mh->axial_fov=(float)0.0;
  mh->transaxial_fov=(float)0.0;

  mh->transaxial_samp_mode=(short)0;
  mh->coin_samp_mode=(short)0;
  mh->axial_samp_mode=(short)0;
  
  mh->calibration_factor=(float)0.0;

  mh->calibration_units=(short)0;
  mh->compression_code=(short)0;

  for (i=0;i<188;i++)
    mh->study_info[i]=' ';
  /*strcpy(mh->study_info,"");*/
  
  mh->aquisition_type=(short)0;
  mh->bed_type=(short)0;
  mh->septa_type=(short)0;
  
  for (i=0;i<20;i++)
    mh->facility_name[i]=' ';
  /*strcpy(mh->facility_name,"");*/

  mh->num_planes=(short)0;
  mh->num_frames=(short)0;
  mh->num_gates=(short)0;
  mh->num_bed_pos=(short)0;

  mh->init_bed_pos=(float)0.0;
  for (i=0;i<15;i++)
    mh->bed_offsets[i]=(float)0.0;
  mh->plane_separation=(float)0.0;
  
  mh->lwr_sctr_thres=(short)0;
  mh->lwr_true_thres=(short)0;
  mh->upr_true_thres=(short)0;
 
  mh->collimator=(float)0.0;
}






void print_main_head(struct main_head *mh)
{
  int i;
  printf("original_file_name=%s\n",mh->original_file_name);
  printf("sw_version=%d\n",(int)mh->sw_version);
  printf("data_type=%d\n",(int)mh->data_type);
  printf("system_type=%d\n",(int)mh->system_type);
  printf("file_type=%d\n",(int)mh->file_type);
  printf("node_id=%s\n",mh->node_id);
  printf("scan_start_day=%d\n",(int)mh->scan_start_day);
  printf("scan_start_month=%d\n",(int)mh->scan_start_month);
  printf("scan_start_year=%d\n",(int)mh->scan_start_year);
  printf("scan_start_hour=%d\n",(int)mh->scan_start_hour);
  printf("scan_start_minute=%d\n",(int)mh->scan_start_minute);
  printf("scan_start_second=%d\n",(int)mh->scan_start_second);
  printf("isotope_code=%s\n",mh->isotope_code);
  printf("isotope_halflife=%f\n",mh->isotope_halflife);
  printf("radiopharmaceutical=%s\n",mh->radiopharmaceutical);
  printf("gantry_tilt=%f\n",mh->gantry_tilt);
  printf("gantry_rotation=%f\n",mh->gantry_rotation);
  printf("bed_elevation=%f\n",mh->bed_elevation);
  printf("rot_source_speed=%d\n",(int)mh->rot_source_speed);
  printf("wobble_speed=%d\n",(int)mh->wobble_speed);
  printf("transm_source_type=%d\n",(int)mh->transm_source_type);
  printf("axial_fov=%f\n",mh->axial_fov);
  printf("transaxial_fov=%f\n",mh->transaxial_fov);
  printf("transaxial_samp_mode=%d\n",(int)mh->transaxial_samp_mode);
  printf("coin_samp_mode=%d\n",(int)mh->coin_samp_mode);
  printf("axial_samp_mode=%d\n",(int)mh->axial_samp_mode);
  printf("calibration_factor=%f\n",mh->calibration_factor);
  printf("calibration_units=%d\n",(int)mh->calibration_units);
  printf("compression_code=%d\n",(int)mh->compression_code);
  printf("study_info=%s\n",mh->study_info);
  printf("aquisition_type=%d\n",(int)mh->aquisition_type);
  printf("bed_type=%d\n",(int)mh->bed_type);
  printf("facility_name=%s\n",mh->facility_name);
  printf("num_planes=%d\n",(int)mh->num_planes);

  printf("num_frames=%d\n",(int)mh->num_frames);

  printf("num_gates=%d\n",(int)mh->num_gates);

  printf("num_bed_pos=%d\n",(int)mh->num_bed_pos);
  printf("init_bed_pos=%f\n",mh->init_bed_pos);
  printf("bed_offsets=[");
  for (i=0;i<17;i++)
    printf("%f  ", mh->bed_offsets[i]);
  printf("]\n");
  printf("plane_separation=%f\n",mh->plane_separation);
  printf("lwr_sctr_thres=%d\n",(int)mh->lwr_sctr_thres);
  printf("lwr_true_thres=%d\n",(int)mh->lwr_true_thres);
  printf("upr_true_thres=%d\n",(int)mh->upr_true_thres);
  printf("collimator=%f\n",mh->collimator);
}



void read_subheader(struct scn_head *sh,FILE *fp, int BYTE_ORDER)
{
 long pos1,pos2;
 
 pos1=ftell(fp);
  
 read_sh_arr(sh->fill, 63, fp, BYTE_ORDER);
 read_sh_arr(&sh->data_type, 1, fp, BYTE_ORDER);
 read_sh_arr(sh->fill1, 2, fp, BYTE_ORDER);
 read_sh_arr(&sh->dimension_1, 1, fp, BYTE_ORDER);
 read_sh_arr(&sh->dimension_2, 1, fp, BYTE_ORDER);
 read_sh_arr(&sh->smoothing, 1, fp, BYTE_ORDER);
 read_sh_arr(&sh->processing_code, 1, fp, BYTE_ORDER);
 read_sh_arr(sh->fill2, 3, fp, BYTE_ORDER);
 read_float_arr(&sh->sample_distance, 1, fp);
 read_sh_arr(sh->fill3, 8, fp, BYTE_ORDER);
 read_float_arr(&sh->isotope_halflife, 1, fp);
 read_sh_arr(&sh->frame_duration_sec, 1, fp, BYTE_ORDER);
 read_lg_arr(&sh->gate_duration,1,fp, BYTE_ORDER);
 read_lg_arr(&sh->r_wave_offset,1,fp, BYTE_ORDER);
 read_sh_arr(&sh->fill4, 1, fp, BYTE_ORDER);
 read_float_arr(&sh->scale_factor, 1, fp);
 read_sh_arr(sh->fill5, 3, fp, BYTE_ORDER);
 read_sh_arr(&sh->scan_min, 1, fp, BYTE_ORDER);
 read_sh_arr(&sh->scan_max, 1, fp, BYTE_ORDER);
 read_lg_arr(&sh->prompts,1,fp, BYTE_ORDER);
 read_lg_arr(&sh->delayed,1,fp, BYTE_ORDER);
 read_lg_arr(&sh->multiples,1,fp, BYTE_ORDER);
 read_lg_arr(&sh->net_trues,1,fp, BYTE_ORDER);
 read_sh_arr(sh->fill6, 52, fp, BYTE_ORDER);
 read_float_arr(sh->cor_singles, 16, fp);
 read_float_arr(sh->uncor_singles, 16, fp);
 read_float_arr(&sh->tot_avg_cor, 1, fp);
 read_float_arr(&sh->tot_avg_uncor, 1, fp);
 read_lg_arr(&sh->tot_coin_rate,1,fp, BYTE_ORDER);
 read_lg_arr(&sh->frame_start_time,1,fp, BYTE_ORDER);
 read_lg_arr(&sh->frame_duration,1,fp, BYTE_ORDER);
 read_float_arr(&sh->loss_correction_factor, 1, fp);
 read_lg_arr(sh->phy_planes,8,fp, BYTE_ORDER);
 read_sh_arr(sh->fill7, 6, fp, BYTE_ORDER);

 pos2=ftell(fp);
 
 if (pos2-pos1!=512)
  {
    fprintf(stderr,"Error: Byte count for subheader read is wrong (%d). Different architecture?\n\a\n",(int)(pos2-pos1));
    exit(-1);
   }

}


void write_subheader(struct scn_head *sh,FILE *fp, int BYTE_ORDER)
{
 long pos1,pos2;
 int i;
 pos1=ftell(fp);
 
 for (i=0;i<63;i++)
   sh->fill[i]=(short)0;
 write_sh_arr(sh->fill, 63, fp, BYTE_ORDER);
 write_sh_arr(&sh->data_type, 1, fp, BYTE_ORDER);

 for (i=0;i<2;i++)
   sh->fill1[i]=(short)0;
 write_sh_arr(sh->fill1, 2, fp, BYTE_ORDER);
 write_sh_arr(&sh->dimension_1, 1, fp, BYTE_ORDER);
 write_sh_arr(&sh->dimension_2, 1, fp, BYTE_ORDER);
 write_sh_arr(&sh->smoothing, 1, fp, BYTE_ORDER);
 write_sh_arr(&sh->processing_code, 1, fp, BYTE_ORDER);
 for (i=0;i<3;i++)
   sh->fill2[i]=(short)0;
 write_sh_arr(sh->fill2, 3, fp, BYTE_ORDER);
 write_float_arr(&sh->sample_distance, 1, fp, BYTE_ORDER);
 for (i=0;i<8;i++)
   sh->fill3[i]=(short)0;
 write_sh_arr(sh->fill3, 8, fp, BYTE_ORDER);
 write_float_arr(&sh->isotope_halflife, 1, fp, BYTE_ORDER);
 write_sh_arr(&sh->frame_duration_sec, 1, fp, BYTE_ORDER);
 write_lg_arr(&sh->gate_duration,1,fp, BYTE_ORDER);
 write_lg_arr(&sh->r_wave_offset,1,fp, BYTE_ORDER);
 sh->fill4=(short)0;
 write_sh_arr(&sh->fill4, 1, fp, BYTE_ORDER);
 write_float_arr(&sh->scale_factor, 1, fp, BYTE_ORDER);
 for (i=0;i<3;i++)
   sh->fill5[i]=(short)0;
 write_sh_arr(sh->fill5, 3, fp, BYTE_ORDER);
 write_sh_arr(&sh->scan_min, 1, fp, BYTE_ORDER);
 write_sh_arr(&sh->scan_max, 1, fp, BYTE_ORDER);
 write_lg_arr(&sh->prompts,1,fp, BYTE_ORDER);
 write_lg_arr(&sh->delayed,1,fp, BYTE_ORDER);
 write_lg_arr(&sh->multiples,1,fp, BYTE_ORDER);
 write_lg_arr(&sh->net_trues,1,fp, BYTE_ORDER);
 for (i=0;i<52;i++)
   sh->fill6[i]=(short)0;
 write_sh_arr(sh->fill6, 52, fp, BYTE_ORDER);
 write_float_arr(sh->cor_singles, 16, fp, BYTE_ORDER);
 write_float_arr(sh->uncor_singles, 16, fp, BYTE_ORDER);
 write_float_arr(&sh->tot_avg_cor, 1, fp, BYTE_ORDER);
 write_float_arr(&sh->tot_avg_uncor, 1, fp, BYTE_ORDER);
 write_lg_arr(&sh->tot_coin_rate,1,fp, BYTE_ORDER);
 write_lg_arr(&sh->frame_start_time,1,fp, BYTE_ORDER);
 write_lg_arr(&sh->frame_duration,1,fp, BYTE_ORDER);
 write_float_arr(&sh->loss_correction_factor, 1, fp, BYTE_ORDER);
 write_lg_arr(sh->phy_planes,8,fp, BYTE_ORDER);
 for (i=0;i<6;i++)
   sh->fill7[i]=(short)0;
 write_sh_arr(sh->fill7, 6, fp, BYTE_ORDER);

 pos2=ftell(fp);
 
 if (pos2-pos1!=512)
  {
    fprintf(stderr,"Error: Byte count for subheader write is wrong (%d). Different architecture?\n\a\n",(int)(pos2-pos1));
    exit(-1);
   }

}



void init_subheader(struct scn_head *sh)
{
  int i;

  sh->data_type=0;
  sh->dimension_1=0;
  sh->dimension_2=0;
  sh->smoothing=0;
  sh->processing_code=0;
  sh->sample_distance=0.0;
  sh->isotope_halflife=0.0;
  sh->frame_duration_sec=0;
  sh->gate_duration=0;
  sh->r_wave_offset=0;
  sh->scale_factor=0.0;
  sh->scan_min=0;
  sh->scan_max=0;
  sh->prompts=0;
  sh->delayed=0;
  sh->multiples=0;
  sh->net_trues=0;
  for (i=0;i<16;i++)
    {
      sh->cor_singles[i]=0.0;
      sh->uncor_singles[i]=0.0;
    }
  sh->tot_avg_cor=0.0;
  sh->tot_avg_uncor=0.0;

  sh->tot_coin_rate=0;
  sh->frame_start_time=0;
  sh->frame_duration=0;

  sh->loss_correction_factor=0.0;

  for (i=0;i<8;i++)
    sh->phy_planes[i]=0;
}







void print_subheader(struct scn_head *sh)
{
 int i;

 printf("data_type=%d\n",(int)sh->data_type);
 printf("dimension_1=%d\n",(int)sh->dimension_1);
 printf("dimension_2=%d\n",(int)sh->dimension_2);
 printf("smoothing=%d\n",(int)sh->smoothing);
 printf("processing_code=%d\n",(int)sh->processing_code);
 printf("sample_distance=%f\n",sh->sample_distance);
 printf("isotope_halflife=%f\n",sh->isotope_halflife);
 printf("frame_duration_sec=%d\n",(int)sh->frame_duration_sec);
 printf("gate_duration=%d\n",(int)sh->gate_duration);
 printf("r_wave_offset=%d\n",(int)sh->r_wave_offset);
 printf("scale_factor=%f\n",sh->scale_factor);
 printf("scan_min=%d\n",(int)sh->scan_min);
 printf("scan_max=%d\n",(int)sh->scan_max);
 printf("prompts=%d\n",(int)sh->prompts);
 printf("delayed=%d\n",(int)sh->delayed);
 printf("multiples=%d\n",(int)sh->multiples);
 printf("net_trues=%d\n",(int)sh->net_trues);

 printf("cor_singles=[");
 for (i=0;i<16;i++)
   printf("%f ",sh->cor_singles[i]);
 printf("]\n");
 
 printf("uncor_singles=[");
 for (i=0;i<16;i++)
   printf("%f ",sh->uncor_singles[i]);
 printf("]\n");
 
 printf("tot_avg_cor=%f\n",sh->tot_avg_cor);
 printf("tot_avg_uncor=%f\n",sh->tot_avg_uncor);
 printf("tot_coin_rate=%d\n",(int)sh->tot_coin_rate);
 printf("frame_start_time=%d\n",(int)sh->frame_start_time);
 printf("frame_duration=%d\n",(int)sh->frame_duration);
 printf("loss_correction_factor=%f\n",sh->loss_correction_factor);
 
 printf("phy_planes=[");
 for (i=0;i<8;i++)
   printf("%d ",(int)sh->phy_planes[i]);
 printf("]\n");
 printf("\n\n");

}

void init_img_head(struct img_shead *ish)
{
  int i;

  ish->data_type=0; /* 128 */        /* all below + 2*/
  ish->num_dimensions=0; /* 128 */
  ish->fill2=0;          /* 130 */
  ish->dimension_1=0;    /* 132 */
  ish->dimension_2=0;    /* 134 */
  ish->x_origin=0.0;       /* 162 */
  ish->y_origin=0.0;       /* 166 */
  ish->recon_scale=0.0;    /* 170 */
  ish->quant_scale=0.0;    /* 174 */
  ish->image_min=0;      /* 176 */
  ish->image_max=0;      /* 178 */
  ish->pixel_size=0.0;     /* 186 */
  ish->slice_width=0.0;    /* 190 */
  ish->frame_duration=0;  /* 194 */
  ish->frame_start_time=0;/* 198 */
  ish->slice_location=0; /* 200 */
  ish->recon_start_hour=0;
  ish->recon_start_min=0;
  ish->recon_start_sec=0;
  ish->recon_duration=0;  /* 210 */
  ish->filter_code=0;    /* 236 */
  ish->scan_matrix_num=0; 
  ish->norm_matrix_num=0;
  ish->atten_cor_mat_num=0; /* 248*/
  ish->image_rotation=0.0;   /* 298 */
  ish->plane_eff_corr_fctr=0.0; /* 302 */
  ish->decay_corr_fctr=0.0;  /* 306 */
  ish->loss_corr_fctr=0.0;   /* 310 */
  ish->processing_code=0;  /* 376 */
  ish->fill8=0;
  ish->quant_units=0;      /* 380 */
  ish->recon_start_day=0;
  ish->recon_start_month=0;
  ish->recon_start_year=0; /* 386 */
  ish->ecat_calibration_fctr=0.0; /* 390 */
  ish->well_counter_cal_fctr=0.0; /* 394 */

  for (i=0;i<6;i++)
    ish->filter_params[i]=0.0; /* 418 */
  
  for (i=0;i<40;i++)
    ish->annotation[i]=' ';
  /*strcpy(ish->annotation,"");*/ /* 458 */
 
}


void write_img_shead(FILE *fp, struct img_shead *sh, int BYTE_ORDER)
{
  long pos1,pos2;
  int i;
  pos1=ftell(fp);
  
  for (i=0;i<63;i++)
    sh->fill[i]=(short)0;
  write_sh_arr(sh->fill, 63, fp, BYTE_ORDER);
  write_sh_arr(&sh->data_type, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->num_dimensions, 1, fp, BYTE_ORDER);
  sh->fill2=(short)0;
  write_sh_arr(&sh->fill2, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->dimension_1, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->dimension_2, 1, fp, BYTE_ORDER);
  for (i=0;i<12;i++)
    sh->fill3[i]=(short)0;
  write_sh_arr(sh->fill3, 12, fp, BYTE_ORDER);
  write_float_arr(&sh->x_origin, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->y_origin, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->recon_scale, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->quant_scale, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->image_min, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->image_max, 1, fp, BYTE_ORDER);
  for (i=0;i<2;i++)
    sh->fill4[i]=(short)0;
  write_sh_arr(sh->fill4, 2, fp, BYTE_ORDER);
  write_float_arr(&sh->pixel_size, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->slice_width, 1, fp, BYTE_ORDER);
  write_lg_arr(&sh->frame_duration, 1, fp, BYTE_ORDER);
  write_lg_arr(&sh->frame_start_time, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->slice_location, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->recon_start_hour, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->recon_start_min, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->recon_start_sec, 1, fp, BYTE_ORDER);
  write_lg_arr(&sh->recon_duration, 1, fp, BYTE_ORDER);
  for (i=0;i<12;i++)
    sh->fill5[i]=(short)0;
  write_sh_arr(sh->fill5, 12, fp, BYTE_ORDER);
  write_sh_arr(&sh->filter_code, 1, fp, BYTE_ORDER);
  write_lg_arr(&sh->scan_matrix_num, 1, fp, BYTE_ORDER);
  write_lg_arr(&sh->norm_matrix_num, 1, fp, BYTE_ORDER);
  write_lg_arr(&sh->atten_cor_mat_num, 1, fp, BYTE_ORDER);
  for (i=0;i<23;i++)
    sh->fill6[i]=(short)0;
  write_sh_arr(sh->fill6, 23, fp, BYTE_ORDER);
  write_float_arr(&sh->image_rotation, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->plane_eff_corr_fctr, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->decay_corr_fctr, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->loss_corr_fctr, 1, fp, BYTE_ORDER);
  for (i=0;i<32;i++)
    sh->fill7[i]=(short)0;
  write_sh_arr(sh->fill7, 32, fp, BYTE_ORDER);
  write_sh_arr(&sh->processing_code, 1, fp, BYTE_ORDER);
  sh->fill8=(short)0;
  write_sh_arr(&sh->fill8, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->quant_units, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->recon_start_day, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->recon_start_month, 1, fp, BYTE_ORDER);
  write_sh_arr(&sh->recon_start_year, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->ecat_calibration_fctr, 1, fp, BYTE_ORDER);
  write_float_arr(&sh->well_counter_cal_fctr, 1, fp, BYTE_ORDER);
  write_float_arr(sh->filter_params, 6, fp, BYTE_ORDER);
  fwrite(sh->annotation,sizeof(char),40,fp);
  for (i=0;i<26;i++)
    sh->fill9[i]=(short)0;
  write_sh_arr(sh->fill9, 26, fp, BYTE_ORDER);

  pos2=ftell(fp);

  if (pos2-pos1 != 512)
    {
      fflush(stderr);fflush(stdout);
      fprintf(stderr,"Error in write_img_shead: %d bytes written (instead of 512). Wrong hardware architecture?\n\a\n",(int)(pos2-pos1));
      exit(-1);
    }


}
