#ifndef FR_ICM_INC
#define FR_ICM_INC


#define TOL 1.0e-9
#define WN 0.14644660940673
#define WD 0.10355339059327
#define SG(A,B) ((A) > (B) ? 1.0 : -1.0)

#include "ansi_lib_loc/A_comp_iupui.h"






struct cmdline_params{
  int no_iter_rec;
  char *output;
  char *cfg_fname;
  char *initial;
  int plane;
  int single_frame; /* -1 for reconstructing all frames, otherwise frame# */
  int sglfr_th0cor_FLAG;
  int resol;
  int INTERP_FLAG;
  int SIGMA_FLAG;
  double sigma;

}; 

struct all_data{  /* all data except transmission attenuation sino */
  double **X; /* recon image, initially CBP */
  double **Y; /* sinog. counts */
  int **mask;
  double scatter;
  struct sino_info sino;
  int Nsup; /* nb pixels w/ mask not zero */
};

struct neighbors{
  double NX[4]; /* hor and vert neighbors */
  double DX[4]; /* diagonal neighbors */

};

struct ICMdata{  /* parameters computed during ICM */
  double D1,D2; /* derivatives */
  struct neighbors neigh; 
  double CX; /* center pixel */
  double ML; 
  double SX; /* old est. sigma^p */
  double P;
};


void  f_pro(double *S,struct all_data *data,struct geom_info *geom,double **profiles,struct column *sp_col);
void get_neighborhood(struct ICMdata *ICMdata,struct all_data *data,struct geom_info *geom,int i,int j);
void minmax(double *low, double *high,double ML, double *NX,double *DX);
double diff_cost(double x,void *ICMdata);
double cost(double x,struct ICMdata *ICMdata);
double updateX(struct ICMdata *ICMdata);
double ICMstep(struct ICMdata *ICMdata,struct all_data *data,double *S,int i,int j,struct geom_info *geom,struct column *sp_col,int *FLAG);
void imgcoord(int *out_i,int *out_j,int s,int iter,int N,int M);
int compute_derivatives(struct ICMdata *ICMdata, struct all_data *data, struct column *sp_col,double *S,int *FLAG2);
void updateS(double *S, struct column *sp_col, double diff);


#endif
